package active;

import javax.swing.*;
import java.awt.*;
import java.util.Observable;
import java.util.Observer;

public class GuiAlertObserver implements Observer {
    public void update(Observable source, Object event) {
        if (!(event instanceof ChangeEvent))
            return;

        ChangeEvent ce = (ChangeEvent) event;

        if (ce.getValue() >= 40) {
            pane.setBackground(Color.RED);
        } else {
            pane.setBackground(Color.GREEN);
        }
    }

    private JPanel pane;

    public Component createComponents() {
        pane = new JPanel();
        pane.setBackground(Color.GREEN);
        return pane;
    }

    public GuiAlertObserver() {
        try {
            UIManager.setLookAndFeel(UIManager
                    .getCrossPlatformLookAndFeelClassName());
        } catch (Exception e) {
            System.err.println("Setting LAF failed!");
        }

        // Create the top-level container and add contents to it.
        JFrame frame = new JFrame("Active Value Alert Observer");

        Component contents = createComponents();
        frame.getContentPane().add(contents, BorderLayout.CENTER);

        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frame.pack();
        frame.setSize(150, 150);

        frame.setVisible(true);
    }
}
