public class DList<T> {

    protected class Node<T> {
	Node<T> prev, next;
	T data;
    }

    private Node<T> first, last;

    public DList() {
	first = new Node<T>();
	last = new Node<T>();
	first.next = last;
	last.prev = first;
    }

    public DList( T[] d ) {
	this();
	for( T x : d ) {
	    add( x );
	}
    }

    public void add( T d ) {
	Node<T> n = new Node<T>();
	n.data = d;
	n.prev = last.prev;
	n.next = last;
	last.prev.next = n;
	last.prev = n;
    }

    public T getFirst() {
	return getFirstNode().data;
    }

    protected Node<T> getFirstNode() {
	return first.next;
    }

    public static void main( String[] args ) {
	Integer[] ia = new Integer[] {1, 2, 3};
	DList<Integer> dl = new DList<Integer>( ia );

	ia[0] = 5;

	System.out.println("First list element: " + dl.getFirst());
    }

}
