package factory;

public class DrawingApplication extends Application {
    public DrawingApplication() {
        super();
        // get cache, ...
    }

    // the overridden factory method returns a concrete
    // object of type ImageDocument.
    protected Document createDocument() {
        return new ImageDocument();
    }

    // behavior of a image application ...

    public static void main(String[] args) {
        DrawingApplication appl = new DrawingApplication();

        appl.newDocument();
        appl.newDocument();
        appl.newDocument();

        appl.saveAll();
        appl.closeAll();
    }
}
